# the speical rspec formatter used in BuildWise Agent to save screenshot
gem "rspec_junit_formatter"
require 'rspec_junit_formatter'
require 'fileutils'
require 'active_support'
require 'active_support/core_ext/object'

module BuildWise
  class RSpecFormatter < RSpecJUnitFormatter

    RSpec::Core::Formatters.register self,
      :example_failed   
      
    def example_failed(notification)      
=begin  
      # In case we fail in before(:all)
      example_started(nil) if @suite.testcases.empty?

      failure = Failure.new(notification)

      current_spec.finish
      current_spec.name = notification.example.full_description
      current_spec.failures << failure
=end
      
      
    	if $driver && $driver.respond_to?("save_screenshot") # shall be set in test script
    	   reports_dir = ENV["BW_TEST_REPORT_DIR"] 
           if reports_dir.nil? || reports_dir.strip.length == 0
               if defined?(AGILEWAY_APP_ROOT)
                 reports_dir = File.expand_path(File.join(AGILEWAY_APP_ROOT, "reports"))
               elsif ENV["BUILDWISE_AGENT_HOME"]
                 reports_dir = File.expand_path(File.join(ENV["BUILDWISE_AGENT_HOME"], "reports"))
               else
                 if RUBY_PLATFORM =~ /darwin/i
                     reports_dir = "~/.buildwise/agent-test-results"
                 elsif RUBY_PLATFORM =~ /linux/
                   reports_dir = "~/.buildwise/agent-test-results"
                 else
                   reports_dir = "C:\\agileway\\.buildwise\\agent-test-results"
                 end
               end
           end
         
           unless File.exist?(reports_dir)
             begin
               FileUtils.mkdir_p(reports_dir)
             rescue => ie
               puts("[WARN] failed to save screenshot due to #{ie}: '#{reports_dir}' ")
             end
           end
         
    	   example_name = notification.example.full_description rescue "test"
         example_name = example_name.parameterize
         report_screenshot_dir = File.join(reports_dir, "screenshots")
         FileUtils.mkdir_p(report_screenshot_dir) unless File.exist?(report_screenshot_dir)
         begin
           $driver.save_screenshot(File.join(report_screenshot_dir, "screenshot-#{example_name}.png"))
         rescue => e
           puts("[WARN] failed to save png: #{example_name}.png")
         end
    	end

    end
   
             
  end  
end
